    # Original idea and script: Chris Fullmer
	# Some enhancements by D. Bur
	def normal_map_maker()
		model=Sketchup.active_model
		s=model.selection
		if s.empty?
			UI.messagebox("No selection. Please select face(s).")
			return
		end
		model.start_operation("Normal map maker")
		view = model.active_view
		Sketchup.send_action("viewTop:")
		old_edgemode=model.rendering_options["EdgeDisplayMode"]
		old_silhouette_mode=model.rendering_options["DrawSilhouettes"]
		model.rendering_options["EdgeDisplayMode"]=0
		model.rendering_options["DrawSilhouettes"]=false
		frontmats_hash={}
		backmats_hash={}
		model.selection.to_a.each do |e|
			if(e.is_a? Sketchup::Face)
				# Save original materials of each face
				frontmats_hash[e]=e.material
				backmats_hash[e]=e.back_material
				colr = [((e.normal[0]+1)/2), ((e.normal[1]+1)/2), ((e.normal[2]+1)/2)]
				e.material = colr
				e.back_material = colr
			end
		end
		model.commit_operation
		view.camera.perspective=false
		path=UI.savepanel("Save Image","c:\\","Normal.png")
		keys={:filename=>path,:width=>view.vpwidth,:height=>view.vpheight,:antialias=>false,:compression=>1.0,:transparent=>true}
		view.zoom_extents
		view.write_image(keys)
		# Reset displays and faces materials, purge materials
		frontmats_hash.each_pair { |f,m| f.material=m }
		backmats_hash.each_pair { |f,m| f.back_material=m }
		model.rendering_options["EdgeDisplayMode"]=old_edgemode
		model.rendering_options["DrawSilhouettes"]=old_silhouette_mode
		model.materials.purge_unused
	end
	
	# ----------------------------------------------------------- Menu item
	if( not file_loaded?("normal_map_maker.rb") )
		add_separator_to_menu("File")
		UI.menu("File").add_item("Export normal map") { normal_map_maker }
	end

	# -----------------------------------------------------------------------------
	file_loaded("normal_map_maker.rb")
	